#include <bits/stdc++.h>

using namespace std;

vector<vector<int> > gr;
vector<int> st;
vector<int> idn, idm;
vector<bool> u;
int n, m;

void dfs(int v){
    u[v]  = true;
    if (v >= n){
        cout << "1 " << v-n+1 << " " << idm[v-n] << endl;
    } else {
        cout << "0 " << v+1 << " " << idn[v] << endl;
    }
    for (int i = 0; i < (int)gr[v].size(); i++){
        int nxt = gr[v][i];
        st[nxt]--;
        if (st[nxt] == 0){
            dfs(nxt);
        }
    }
}

void solve(){
    u.assign(n+m, false);
    for (int i = 0; i < n; i++){
        if (!u[i] && idn[i] > 0 && st[i] == 0){
            dfs(i);
        }
    }
    for (int j = 0; j < m; j++){
        if (!u[n+j] && idm[j] > 0 && st[n+j] == 0){
            dfs(n+j);
        }
    }
}

int main(){
    int g;
    cin >> n >> m >> g;
    vector<vector<int> > a(n, vector<int>(m));
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            cin >> a[i][j];
        }
    }
    idn.assign(n, 0);
    idm.assign(m, 0);
    gr.resize(n+m);
    st.assign(n+m, 0);
    for (int i = 0; i < n; i++){
        unordered_map<int, bool> used;
        for (int j = 0; j < m; j++){
            if (a[i][j] == 0){
                idn[i] = -1;
                break;
            }
            if (used[a[i][j]]){
                idn[i] = a[i][j];
                break;
            }
            used[a[i][j]] = true;
        }
        if (idn[i] > 0){
            for (int j = 0; j < m; j++){
                if (a[i][j] && a[i][j] != idn[i]){
                    gr[i].push_back(n+j);
                    st[n+j]++;
                }
            }
        }
    }
    for (int j = 0; j < m; j++){
        unordered_map<int, bool> used;
        for (int i = 0; i < n; i++){
            if (a[i][j] == 0){
                idm[j] = -1;
                break;
            }
            if (used[a[i][j]]){
                idm[j] = a[i][j];
                break;
            }
            used[a[i][j]] = true;
        }
        if (idm[j] > 0){
            for (int i = 0; i < n; i++){
                if (a[i][j] && a[i][j] != idm[j]){
                    gr[n+j].push_back(i);
                    st[i]++;
                }
            }
        }
    }
    vector<int> ndi, ndj;
    for (int i = 0; i < n; i++){
        if (idn[i] == 0){
            ndi.push_back(i);
        }
    }
    for (int i = 0; i < m; i++){
        if (idm[i] == 0){
            ndj.push_back(i);
        }
    }
    if (ndj.size() == 0){
        for (int k = 0; k < (int)ndi.size(); k++){
            int i = ndi[k];
            idn[i] = -1;
            for (int j = 0; j < m; j++){
                if (idm[j] != a[i][j]){
                    idn[i] = a[i][j];
                    break;
                }
            }
            if (idn[i] > 0){
                for (int j = 0; j < m; j++){
                    if (a[i][j] != idn[i]){
                        gr[i].push_back(n+j);
                        st[n+j]++;
                    }
                }
            }
        }
    }
    if (ndi.size() == 0){
        for (int k = 0; k < (int)ndj.size(); k++){
            int j = ndj[k];
            idm[j] = -1;
            for (int i = 0; i < n; i++){
                if (idn[i] != a[i][j]){
                    idm[j] = a[i][j];
                    break;
                }
            }
            if (idm[j] > 0){
                for (int i = 0; i < n; i++){
                    if (a[i][j] != idm[j]){
                        gr[n+j].push_back(i);
                        st[i]++;
                    }
                }
            }
        }
    }
//    for (int i = 0; i < n; i++){
//        cout << idn[i] << " ";
//    }
//    cout << endl;
//    for (int i = 0; i < m; i++){
//        cout << idm[i] << " ";
//    }
//    cout << endl;
//    for (int i = 0; i < n+m; i++){
//        cout << st[i] << " ";
//    }
//    cout << endl;
    solve();
}







