#include <iostream>
#include <cmath>
#include <cstdio>

using namespace std;

int primes[78498];
int amount[78498][102];
int n, empty_prime = 0;
int nod = 1;
int ans;

bool is_prime(int num) {
    int sq = sqrt(num);
    for (int i = 2; i <= sq; ++i) {
        if (num % i == 0) {
            return false;
        }
    }
    return true;
}

int main() {
    for (int i = 2; i < 1000000; ++i) {
        if (is_prime(i)) {
            primes[empty_prime] = i;
            empty_prime ++;
        }
    }
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    int a[n];
    for (int i = 0; i < n; ++ i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++ i) {
        for (int j = 0; j < 78498; ++ j) {
            while(a[i] % primes[j] == 0) {
                amount[j][i] ++;
                amount[j][101]++;
                a[i] /= primes[j];
                if (amount[j][101] == n) {
                    amount[j][101] = 0;
                    amount[j][100] ++;
                    nod *= primes[j];
                }
            }
        }
    }
    cout << nod << " ";
    for (int i = 0; i < n; ++ i) {
        for (int j = 0; j < 78498; ++ j) {
            if (amount[j][i] < amount[j][100]) {
                ans += amount[j][100] - amount[j][i];
            }
        }
    }
    cout << ans << endl;
}
